/* Problem URL: https://codeforces.com/contest/893/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll d;
    cin >> n >> d;

    vl fds(n);
    cin >> fds;

    ll test = 0;
    vl trans(n);
    rep(i, n) {
        test += fds[i];

        if (test > d) {
            cout << "-1\n";
            return 0;
        }

        trans[i] = test;
    }

    vvl sparse(n, vl(20));
    // vvl minimal(n, vl(20));

    rep(i, n) {
        sparse[i][0] = trans[i];
        // minimal[i][0] = trans[i];
    }

    nrep(j, 1, 20) {
        for (int i = 0; i + (1 << (j - 1)) < n; i++) {
            sparse[i][j] = max(sparse[i][j - 1], sparse[i + (1 << (j - 1))][j - 1]);
            // minimal[i][j] = min(minimal[i][j - 1], minimal[i + (j << 1)][j - 1]);
        }
    }

    auto query = [&](int l, int r) {
        int log = 31 - __builtin_clz(r - l + 1);

        return max(sparse[l][log], sparse[r - (1 << log) + 1][log]);
    };

    // auto minquery = [&](int l, int r) {
    //     int log = 31 - __builtin_clz(r - l + 1);
    //     
    //     return min(minimal[l][log], minimal[r - (1 << log) + 1][log]);
    // };

    int i = 0;

    ll added = 0;
    int ans = 0;

    rep(i, n) {
        if (fds[i] == 0) {
            if (trans[i] + added < 0) {
                ll maximal = query(i, n - 1);
                ll act = trans[i] + added;

                ll now = d - (maximal + added);

                if (now < -act) {
                    cout << "-1\n";
                    return 0;
                }

                ans++;
                added += now;
            }
        }
    }

    cout << ans << '\n';
}
